/*
 * JNI wrapper implementation automatically generated by extract_java_stub.py
 */
#include <stdlib.h>
#include "mathsat_api.h"


#include "mathsat.h"


struct j_msat_all_sat_helper {
   JNIEnv *jenv;
   jobject obj;
};

static void call_java_callback(msat_term *model, int size, void *user_data)
{
    struct j_msat_all_sat_helper *helper =
        (struct j_msat_all_sat_helper *)user_data;

    const char *signature = "([J)V";
    jclass cls = (*(helper->jenv))->FindClass(helper->jenv,
                                              "mathsat/AllSatModelCallback");
    jmethodID mid = (*(helper->jenv))->GetMethodID(helper->jenv, cls,
                                                   "callback", signature);    
        
    jlongArray jmodel = (*(helper->jenv))->NewLongArray(helper->jenv,
                                                        (size_t)size);
    jlong *jarr = malloc(sizeof(jlong) * size);
    int i;
    for (i = 0; i < size; ++i) {
        jarr[i] = (jlong)((size_t)model[i].repr);
    }
    (*(helper->jenv))->SetLongArrayRegion(helper->jenv, jmodel, 0, (size_t)size,
                                          (jlong *)jarr);

    (*(helper->jenv))->CallVoidMethod(helper->jenv, helper->obj, mid, jmodel);
    free(jarr);
}



JNIEXPORT void JNICALL Java_mathsat_api_msat_1set_1verbosity
  (JNIEnv *jenv, jclass jcls, jint arg1)
{
  int arg1_level;

arg1_level = arg1;

  msat_set_verbosity(arg1_level);

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1env
  (JNIEnv *jenv, jclass jcls)
{
  msat_env msat_create_env_retval;
  jlong msat_create_env_jretval;


  msat_create_env_retval = msat_create_env();

  msat_create_env_jretval = (jlong)((size_t)(msat_create_env_retval.repr));

  return msat_create_env_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1shared_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_sibling;
  msat_env msat_create_shared_env_retval;
  jlong msat_create_shared_env_jretval;

arg1_sibling.repr = (void *)((size_t)arg1);

  msat_create_shared_env_retval = msat_create_shared_env(arg1_sibling);

  msat_create_shared_env_jretval = (jlong)((size_t)(msat_create_shared_env_retval.repr));

  return msat_create_shared_env_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1reset_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;

arg1_e.repr = (void *)((size_t)arg1);

  msat_reset_env(arg1_e);

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;

arg1_e.repr = (void *)((size_t)arg1);

  msat_destroy_env(arg1_e);

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1set_1option
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jstring arg3)
{
  msat_env arg1_e;
  char * arg2_option;
  char * arg3_value;
  int msat_set_option_retval;
  jint msat_set_option_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_option = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_option == NULL) return 0; /* out of memory error */
arg3_value = (char *)(*jenv)->GetStringUTFChars(jenv, arg3, NULL);
if (arg3_value == NULL) return 0; /* out of memory error */

  msat_set_option_retval = msat_set_option(arg1_e, arg2_option, arg3_value);

  msat_set_option_jretval = (jint)msat_set_option_retval;
(*jenv)->ReleaseStringUTFChars(jenv, arg3, arg3_value);
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_option);

  return msat_set_option_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1declare_1variable
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3)
{
  msat_env arg1_e;
  char * arg2_name;
  msat_type arg3_type;
  msat_decl msat_declare_variable_retval;
  jlong msat_declare_variable_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_name = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_name == NULL) return 0; /* out of memory error */
arg3_type = arg3;

  msat_declare_variable_retval = msat_declare_variable(arg1_e, arg2_name, arg3_type);

  msat_declare_variable_jretval = (jlong)((size_t)(msat_declare_variable_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_name);

  return msat_declare_variable_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1declare_1uif
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jint arg3, jint arg4, jintArray arg5)
{
  msat_env arg1_e;
  char * arg2_name;
  msat_type arg3_out_type;
  int arg4_num_args;
  msat_type * arg5_args_types;
  msat_decl msat_declare_uif_retval;
  jlong msat_declare_uif_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_name = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_name == NULL) return 0; /* out of memory error */
arg3_out_type = arg3;
arg4_num_args = arg4;
arg5_args_types = (int *)((*jenv)->GetIntArrayElements(jenv, arg5, NULL));
if (arg5_args_types == NULL) return 0; /* out of memory error */


  msat_declare_uif_retval = msat_declare_uif(arg1_e, arg2_name, arg3_out_type, arg4_num_args, arg5_args_types);

  msat_declare_uif_jretval = (jlong)((size_t)(msat_declare_uif_retval.repr));
(*jenv)->ReleaseIntArrayElements(jenv, arg5, arg5_args_types, 0);

(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_name);

  return msat_declare_uif_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1true
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_true_retval;
  jlong msat_make_true_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_true_retval = msat_make_true(arg1_e);

  msat_make_true_jretval = (jlong)((size_t)(msat_make_true_retval.repr));

  return msat_make_true_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1false
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_make_false_retval;
  jlong msat_make_false_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_make_false_retval = msat_make_false(arg1_e);

  msat_make_false_jretval = (jlong)((size_t)(msat_make_false_retval.repr));

  return msat_make_false_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1iff
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_iff_retval;
  jlong msat_make_iff_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_iff_retval = msat_make_iff(arg1_e, arg2_t1, arg3_t2);

  msat_make_iff_jretval = (jlong)((size_t)(msat_make_iff_retval.repr));

  return msat_make_iff_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1implies
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_implies_retval;
  jlong msat_make_implies_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_implies_retval = msat_make_implies(arg1_e, arg2_t1, arg3_t2);

  msat_make_implies_jretval = (jlong)((size_t)(msat_make_implies_retval.repr));

  return msat_make_implies_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_or_retval;
  jlong msat_make_or_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_or_retval = msat_make_or(arg1_e, arg2_t1, arg3_t2);

  msat_make_or_jretval = (jlong)((size_t)(msat_make_or_retval.repr));

  return msat_make_or_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1xor
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_xor_retval;
  jlong msat_make_xor_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_xor_retval = msat_make_xor(arg1_e, arg2_t1, arg3_t2);

  msat_make_xor_jretval = (jlong)((size_t)(msat_make_xor_retval.repr));

  return msat_make_xor_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_and_retval;
  jlong msat_make_and_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_and_retval = msat_make_and(arg1_e, arg2_t1, arg3_t2);

  msat_make_and_jretval = (jlong)((size_t)(msat_make_and_retval.repr));

  return msat_make_and_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term msat_make_not_retval;
  jlong msat_make_not_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);

  msat_make_not_retval = msat_make_not(arg1_e, arg2_t1);

  msat_make_not_jretval = (jlong)((size_t)(msat_make_not_retval.repr));

  return msat_make_not_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1equal
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_equal_retval;
  jlong msat_make_equal_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_equal_retval = msat_make_equal(arg1_e, arg2_t1, arg3_t2);

  msat_make_equal_jretval = (jlong)((size_t)(msat_make_equal_retval.repr));

  return msat_make_equal_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1lt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_lt_retval;
  jlong msat_make_lt_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_lt_retval = msat_make_lt(arg1_e, arg2_t1, arg3_t2);

  msat_make_lt_jretval = (jlong)((size_t)(msat_make_lt_retval.repr));

  return msat_make_lt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1gt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_gt_retval;
  jlong msat_make_gt_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_gt_retval = msat_make_gt(arg1_e, arg2_t1, arg3_t2);

  msat_make_gt_jretval = (jlong)((size_t)(msat_make_gt_retval.repr));

  return msat_make_gt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1leq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_leq_retval;
  jlong msat_make_leq_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_leq_retval = msat_make_leq(arg1_e, arg2_t1, arg3_t2);

  msat_make_leq_jretval = (jlong)((size_t)(msat_make_leq_retval.repr));

  return msat_make_leq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1geq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_geq_retval;
  jlong msat_make_geq_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_geq_retval = msat_make_geq(arg1_e, arg2_t1, arg3_t2);

  msat_make_geq_jretval = (jlong)((size_t)(msat_make_geq_retval.repr));

  return msat_make_geq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_plus_retval;
  jlong msat_make_plus_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_plus_retval = msat_make_plus(arg1_e, arg2_t1, arg3_t2);

  msat_make_plus_jretval = (jlong)((size_t)(msat_make_plus_retval.repr));

  return msat_make_plus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_minus_retval;
  jlong msat_make_minus_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_minus_retval = msat_make_minus(arg1_e, arg2_t1, arg3_t2);

  msat_make_minus_jretval = (jlong)((size_t)(msat_make_minus_retval.repr));

  return msat_make_minus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_times_retval;
  jlong msat_make_times_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_times_retval = msat_make_times(arg1_e, arg2_t1, arg3_t2);

  msat_make_times_jretval = (jlong)((size_t)(msat_make_times_retval.repr));

  return msat_make_times_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1negate
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_negate_retval;
  jlong msat_make_negate_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_negate_retval = msat_make_negate(arg1_e, arg2_t);

  msat_make_negate_jretval = (jlong)((size_t)(msat_make_negate_retval.repr));

  return msat_make_negate_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_num_rep;
  msat_term msat_make_number_retval;
  jlong msat_make_number_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_num_rep = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_num_rep == NULL) return 0; /* out of memory error */

  msat_make_number_retval = msat_make_number(arg1_e, arg2_num_rep);

  msat_make_number_jretval = (jlong)((size_t)(msat_make_number_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_num_rep);

  return msat_make_number_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1ite
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3, jlong arg4)
{
  msat_env arg1_e;
  msat_term arg2_c;
  msat_term arg3_tt;
  msat_term arg4_te;
  msat_term msat_make_ite_retval;
  jlong msat_make_ite_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_c.repr = (void *)((size_t)arg2);
arg3_tt.repr = (void *)((size_t)arg3);
arg4_te.repr = (void *)((size_t)arg4);

  msat_make_ite_retval = msat_make_ite(arg1_e, arg2_c, arg3_tt, arg4_te);

  msat_make_ite_jretval = (jlong)((size_t)(msat_make_ite_retval.repr));

  return msat_make_ite_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1variable
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_decl arg2_var;
  msat_term msat_make_variable_retval;
  jlong msat_make_variable_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_var.repr = (void *)((size_t)arg2);

  msat_make_variable_retval = msat_make_variable(arg1_e, arg2_var);

  msat_make_variable_jretval = (jlong)((size_t)(msat_make_variable_retval.repr));

  return msat_make_variable_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1uif
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3)
{
  msat_env arg1_e;
  msat_decl arg2_func;
  msat_term * arg3_args;
  msat_term msat_make_uif_retval;
  jlong msat_make_uif_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_func.repr = (void *)((size_t)arg2);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  if (tmp == NULL) return 0; /* out of memory error */
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_args = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_args[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}


  msat_make_uif_retval = msat_make_uif(arg1_e, arg2_func, arg3_args);

  msat_make_uif_jretval = (jlong)((size_t)(msat_make_uif_retval.repr));
free(arg3_args);

  return msat_make_uif_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1concat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_concat_retval;
  jlong msat_make_bv_concat_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_concat_retval = msat_make_bv_concat(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_concat_jretval = (jlong)((size_t)(msat_make_bv_concat_retval.repr));

  return msat_make_bv_concat_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1select
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jint arg3, jint arg4)
{
  msat_env arg1_e;
  msat_term arg2_t;
  unsigned arg3_msb;
  unsigned arg4_lsb;
  msat_term msat_make_bv_select_retval;
  jlong msat_make_bv_select_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
arg3_msb = arg3;
arg4_lsb = arg4;

  msat_make_bv_select_retval = msat_make_bv_select(arg1_e, arg2_t, arg3_msb, arg4_lsb);

  msat_make_bv_select_jretval = (jlong)((size_t)(msat_make_bv_select_retval.repr));

  return msat_make_bv_select_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_or_retval;
  jlong msat_make_bv_or_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_or_retval = msat_make_bv_or(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_or_jretval = (jlong)((size_t)(msat_make_bv_or_retval.repr));

  return msat_make_bv_or_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1xor
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_xor_retval;
  jlong msat_make_bv_xor_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_xor_retval = msat_make_bv_xor(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_xor_jretval = (jlong)((size_t)(msat_make_bv_xor_retval.repr));

  return msat_make_bv_xor_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_and_retval;
  jlong msat_make_bv_and_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_and_retval = msat_make_bv_and(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_and_jretval = (jlong)((size_t)(msat_make_bv_and_retval.repr));

  return msat_make_bv_and_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term msat_make_bv_not_retval;
  jlong msat_make_bv_not_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_make_bv_not_retval = msat_make_bv_not(arg1_e, arg2_t);

  msat_make_bv_not_jretval = (jlong)((size_t)(msat_make_bv_not_retval.repr));

  return msat_make_bv_not_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1lsl
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_lsl_retval;
  jlong msat_make_bv_lsl_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_lsl_retval = msat_make_bv_lsl(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_lsl_jretval = (jlong)((size_t)(msat_make_bv_lsl_retval.repr));

  return msat_make_bv_lsl_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1lsr
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_lsr_retval;
  jlong msat_make_bv_lsr_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_lsr_retval = msat_make_bv_lsr(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_lsr_jretval = (jlong)((size_t)(msat_make_bv_lsr_retval.repr));

  return msat_make_bv_lsr_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1asr
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_asr_retval;
  jlong msat_make_bv_asr_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_asr_retval = msat_make_bv_asr(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_asr_jretval = (jlong)((size_t)(msat_make_bv_asr_retval.repr));

  return msat_make_bv_asr_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1zext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jint arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  unsigned arg3_width;
  msat_term msat_make_bv_zext_retval;
  jlong msat_make_bv_zext_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
arg3_width = arg3;

  msat_make_bv_zext_retval = msat_make_bv_zext(arg1_e, arg2_t, arg3_width);

  msat_make_bv_zext_jretval = (jlong)((size_t)(msat_make_bv_zext_retval.repr));

  return msat_make_bv_zext_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sext
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jint arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  unsigned arg3_width;
  msat_term msat_make_bv_sext_retval;
  jlong msat_make_bv_sext_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
arg3_width = arg3;

  msat_make_bv_sext_retval = msat_make_bv_sext(arg1_e, arg2_t, arg3_width);

  msat_make_bv_sext_jretval = (jlong)((size_t)(msat_make_bv_sext_retval.repr));

  return msat_make_bv_sext_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_plus_retval;
  jlong msat_make_bv_plus_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_plus_retval = msat_make_bv_plus(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_plus_jretval = (jlong)((size_t)(msat_make_bv_plus_retval.repr));

  return msat_make_bv_plus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_minus_retval;
  jlong msat_make_bv_minus_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_minus_retval = msat_make_bv_minus(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_minus_jretval = (jlong)((size_t)(msat_make_bv_minus_retval.repr));

  return msat_make_bv_minus_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_times_retval;
  jlong msat_make_bv_times_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_times_retval = msat_make_bv_times(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_times_jretval = (jlong)((size_t)(msat_make_bv_times_retval.repr));

  return msat_make_bv_times_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1udiv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_udiv_retval;
  jlong msat_make_bv_udiv_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_udiv_retval = msat_make_bv_udiv(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_udiv_jretval = (jlong)((size_t)(msat_make_bv_udiv_retval.repr));

  return msat_make_bv_udiv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1urem
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_urem_retval;
  jlong msat_make_bv_urem_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_urem_retval = msat_make_bv_urem(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_urem_jretval = (jlong)((size_t)(msat_make_bv_urem_retval.repr));

  return msat_make_bv_urem_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sdiv
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_sdiv_retval;
  jlong msat_make_bv_sdiv_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_sdiv_retval = msat_make_bv_sdiv(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_sdiv_jretval = (jlong)((size_t)(msat_make_bv_sdiv_retval.repr));

  return msat_make_bv_sdiv_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1srem
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_srem_retval;
  jlong msat_make_bv_srem_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_srem_retval = msat_make_bv_srem(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_srem_jretval = (jlong)((size_t)(msat_make_bv_srem_retval.repr));

  return msat_make_bv_srem_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1smod
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_smod_retval;
  jlong msat_make_bv_smod_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_smod_retval = msat_make_bv_smod(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_smod_jretval = (jlong)((size_t)(msat_make_bv_smod_retval.repr));

  return msat_make_bv_smod_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1ult
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_ult_retval;
  jlong msat_make_bv_ult_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_ult_retval = msat_make_bv_ult(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_ult_jretval = (jlong)((size_t)(msat_make_bv_ult_retval.repr));

  return msat_make_bv_ult_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1uleq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_uleq_retval;
  jlong msat_make_bv_uleq_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_uleq_retval = msat_make_bv_uleq(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_uleq_jretval = (jlong)((size_t)(msat_make_bv_uleq_retval.repr));

  return msat_make_bv_uleq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1ugt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_ugt_retval;
  jlong msat_make_bv_ugt_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_ugt_retval = msat_make_bv_ugt(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_ugt_jretval = (jlong)((size_t)(msat_make_bv_ugt_retval.repr));

  return msat_make_bv_ugt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1ugeq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_ugeq_retval;
  jlong msat_make_bv_ugeq_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_ugeq_retval = msat_make_bv_ugeq(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_ugeq_jretval = (jlong)((size_t)(msat_make_bv_ugeq_retval.repr));

  return msat_make_bv_ugeq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1slt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_slt_retval;
  jlong msat_make_bv_slt_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_slt_retval = msat_make_bv_slt(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_slt_jretval = (jlong)((size_t)(msat_make_bv_slt_retval.repr));

  return msat_make_bv_slt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sleq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_sleq_retval;
  jlong msat_make_bv_sleq_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_sleq_retval = msat_make_bv_sleq(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_sleq_jretval = (jlong)((size_t)(msat_make_bv_sleq_retval.repr));

  return msat_make_bv_sleq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sgt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_sgt_retval;
  jlong msat_make_bv_sgt_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_sgt_retval = msat_make_bv_sgt(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_sgt_jretval = (jlong)((size_t)(msat_make_bv_sgt_retval.repr));

  return msat_make_bv_sgt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1bv_1sgeq
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t1;
  msat_term arg3_t2;
  msat_term msat_make_bv_sgeq_retval;
  jlong msat_make_bv_sgeq_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t1.repr = (void *)((size_t)arg2);
arg3_t2.repr = (void *)((size_t)arg3);

  msat_make_bv_sgeq_retval = msat_make_bv_sgeq(arg1_e, arg2_t1, arg3_t2);

  msat_make_bv_sgeq_jretval = (jlong)((size_t)(msat_make_bv_sgeq_retval.repr));

  return msat_make_bv_sgeq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1string
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_repr;
  msat_term msat_from_string_retval;
  jlong msat_from_string_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_repr = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_repr == NULL) return 0; /* out of memory error */

  msat_from_string_retval = msat_from_string(arg1_e, arg2_repr);

  msat_from_string_jretval = (jlong)((size_t)(msat_from_string_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_repr);

  return msat_from_string_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1string_1and_1name
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2, jstring arg3)
{
  msat_env arg1_e;
  char * arg2_repr;
  char * arg3_name;
  msat_term msat_from_string_and_name_retval;
  jlong msat_from_string_and_name_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_repr = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_repr == NULL) return 0; /* out of memory error */
arg3_name = (char *)(*jenv)->GetStringUTFChars(jenv, arg3, NULL);
if (arg3_name == NULL) return 0; /* out of memory error */

  msat_from_string_and_name_retval = msat_from_string_and_name(arg1_e, arg2_repr, arg3_name);

  msat_from_string_and_name_jretval = (jlong)((size_t)(msat_from_string_and_name_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg3, arg3_name);
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_repr);

  return msat_from_string_and_name_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1make_1copy_1from
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlong arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_env arg3_src;
  msat_term msat_make_copy_from_retval;
  jlong msat_make_copy_from_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
arg3_src.repr = (void *)((size_t)arg3);

  msat_make_copy_from_retval = msat_make_copy_from(arg1_e, arg2_t, arg3_src);

  msat_make_copy_from_jretval = (jlong)((size_t)(msat_make_copy_from_retval.repr));

  return msat_make_copy_from_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1replace_1args
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3)
{
  msat_env arg1_e;
  msat_term arg2_t;
  msat_term * arg3_newargs;
  msat_term msat_replace_args_retval;
  jlong msat_replace_args_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);
{
  size_t i, sz;
  jlong *tmp = (jlong *)((*jenv)->GetLongArrayElements(jenv, arg3, NULL));
  if (tmp == NULL) return 0; /* out of memory error */
  sz = (size_t)((*jenv)->GetArrayLength(jenv, arg3));
  arg3_newargs = (msat_term *)malloc(sizeof(msat_term) * sz);
  for (i = 0; i < sz; ++i) {
     arg3_newargs[i].repr = (void *)((size_t)tmp[i]);
  }
  (*jenv)->ReleaseLongArrayElements(jenv, arg3, tmp, 0);
}


  msat_replace_args_retval = msat_replace_args(arg1_e, arg2_t, arg3_newargs);

  msat_replace_args_jretval = (jlong)((size_t)(msat_replace_args_retval.repr));
free(arg3_newargs);

  return msat_replace_args_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1msat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_data;
  msat_term msat_from_msat_retval;
  jlong msat_from_msat_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_data == NULL) return 0; /* out of memory error */

  msat_from_msat_retval = msat_from_msat(arg1_e, arg2_data);

  msat_from_msat_jretval = (jlong)((size_t)(msat_from_msat_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_from_msat_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1smt
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_data;
  msat_term msat_from_smt_retval;
  jlong msat_from_smt_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_data == NULL) return 0; /* out of memory error */

  msat_from_smt_retval = msat_from_smt(arg1_e, arg2_data);

  msat_from_smt_jretval = (jlong)((size_t)(msat_from_smt_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_from_smt_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1from_1foci
  (JNIEnv *jenv, jclass jcls, jlong arg1, jstring arg2)
{
  msat_env arg1_e;
  char * arg2_data;
  msat_term msat_from_foci_retval;
  jlong msat_from_foci_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_data = (char *)(*jenv)->GetStringUTFChars(jenv, arg2, NULL);
if (arg2_data == NULL) return 0; /* out of memory error */

  msat_from_foci_retval = msat_from_foci(arg1_e, arg2_data);

  msat_from_foci_jretval = (jlong)((size_t)(msat_from_foci_retval.repr));
(*jenv)->ReleaseStringUTFChars(jenv, arg2, arg2_data);

  return msat_from_foci_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1to_1msat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  char * msat_to_msat_retval;
  jstring msat_to_msat_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_to_msat_retval = msat_to_msat(arg1_e, arg2_term);

  msat_to_msat_jretval = (*jenv)->NewStringUTF(jenv, msat_to_msat_retval);

  free(msat_to_msat_retval);

  return msat_to_msat_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1to_1smtlib
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  char * msat_to_smtlib_retval;
  jstring msat_to_smtlib_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_to_smtlib_retval = msat_to_smtlib(arg1_e, arg2_term);

  msat_to_smtlib_jretval = (*jenv)->NewStringUTF(jenv, msat_to_smtlib_retval);

  free(msat_to_smtlib_retval);

  return msat_to_smtlib_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1id
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_id_retval;
  jint msat_term_id_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_id_retval = msat_term_id(arg1_t);

  msat_term_id_jretval = (jint)msat_term_id_retval;

  return msat_term_id_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1arity
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_arity_retval;
  jint msat_term_arity_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_arity_retval = msat_term_arity(arg1_t);

  msat_term_arity_jretval = (jint)msat_term_arity_retval;

  return msat_term_arity_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1term_1get_1arg
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_term arg1_t;
  int arg2_n;
  msat_term msat_term_get_arg_retval;
  jlong msat_term_get_arg_jretval;

arg1_t.repr = (void *)((size_t)arg1);
arg2_n = arg2;

  msat_term_get_arg_retval = msat_term_get_arg(arg1_t, arg2_n);

  msat_term_get_arg_jretval = (jlong)((size_t)(msat_term_get_arg_retval.repr));

  return msat_term_get_arg_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1get_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  msat_type msat_term_get_type_retval;
  jint msat_term_get_type_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_get_type_retval = msat_term_get_type(arg1_t);

  msat_term_get_type_jretval = (jint)msat_term_get_type_retval;

  return msat_term_get_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1true
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_true_retval;
  jint msat_term_is_true_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_true_retval = msat_term_is_true(arg1_t);

  msat_term_is_true_jretval = (jint)msat_term_is_true_retval;

  return msat_term_is_true_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1false
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_false_retval;
  jint msat_term_is_false_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_false_retval = msat_term_is_false(arg1_t);

  msat_term_is_false_jretval = (jint)msat_term_is_false_retval;

  return msat_term_is_false_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1boolean_1var
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_boolean_var_retval;
  jint msat_term_is_boolean_var_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_boolean_var_retval = msat_term_is_boolean_var(arg1_t);

  msat_term_is_boolean_var_jretval = (jint)msat_term_is_boolean_var_retval;

  return msat_term_is_boolean_var_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1atom
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_atom_retval;
  jint msat_term_is_atom_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_atom_retval = msat_term_is_atom(arg1_t);

  msat_term_is_atom_jretval = (jint)msat_term_is_atom_retval;

  return msat_term_is_atom_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1number
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_number_retval;
  jint msat_term_is_number_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_number_retval = msat_term_is_number(arg1_t);

  msat_term_is_number_jretval = (jint)msat_term_is_number_retval;

  return msat_term_is_number_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_and_retval;
  jint msat_term_is_and_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_and_retval = msat_term_is_and(arg1_t);

  msat_term_is_and_jretval = (jint)msat_term_is_and_retval;

  return msat_term_is_and_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_or_retval;
  jint msat_term_is_or_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_or_retval = msat_term_is_or(arg1_t);

  msat_term_is_or_jretval = (jint)msat_term_is_or_retval;

  return msat_term_is_or_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_not_retval;
  jint msat_term_is_not_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_not_retval = msat_term_is_not(arg1_t);

  msat_term_is_not_jretval = (jint)msat_term_is_not_retval;

  return msat_term_is_not_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1iff
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_iff_retval;
  jint msat_term_is_iff_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_iff_retval = msat_term_is_iff(arg1_t);

  msat_term_is_iff_jretval = (jint)msat_term_is_iff_retval;

  return msat_term_is_iff_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1implies
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_implies_retval;
  jint msat_term_is_implies_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_implies_retval = msat_term_is_implies(arg1_t);

  msat_term_is_implies_jretval = (jint)msat_term_is_implies_retval;

  return msat_term_is_implies_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1xor
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_xor_retval;
  jint msat_term_is_xor_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_xor_retval = msat_term_is_xor(arg1_t);

  msat_term_is_xor_jretval = (jint)msat_term_is_xor_retval;

  return msat_term_is_xor_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bool_1ite
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bool_ite_retval;
  jint msat_term_is_bool_ite_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bool_ite_retval = msat_term_is_bool_ite(arg1_t);

  msat_term_is_bool_ite_jretval = (jint)msat_term_is_bool_ite_retval;

  return msat_term_is_bool_ite_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1term_1ite
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_term_ite_retval;
  jint msat_term_is_term_ite_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_term_ite_retval = msat_term_is_term_ite(arg1_t);

  msat_term_is_term_ite_jretval = (jint)msat_term_is_term_ite_retval;

  return msat_term_is_term_ite_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1variable
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_variable_retval;
  jint msat_term_is_variable_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_variable_retval = msat_term_is_variable(arg1_t);

  msat_term_is_variable_jretval = (jint)msat_term_is_variable_retval;

  return msat_term_is_variable_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1uif
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_uif_retval;
  jint msat_term_is_uif_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_uif_retval = msat_term_is_uif(arg1_t);

  msat_term_is_uif_jretval = (jint)msat_term_is_uif_retval;

  return msat_term_is_uif_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1equal
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_equal_retval;
  jint msat_term_is_equal_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_equal_retval = msat_term_is_equal(arg1_t);

  msat_term_is_equal_jretval = (jint)msat_term_is_equal_retval;

  return msat_term_is_equal_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1lt
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_lt_retval;
  jint msat_term_is_lt_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_lt_retval = msat_term_is_lt(arg1_t);

  msat_term_is_lt_jretval = (jint)msat_term_is_lt_retval;

  return msat_term_is_lt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1leq
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_leq_retval;
  jint msat_term_is_leq_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_leq_retval = msat_term_is_leq(arg1_t);

  msat_term_is_leq_jretval = (jint)msat_term_is_leq_retval;

  return msat_term_is_leq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1gt
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_gt_retval;
  jint msat_term_is_gt_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_gt_retval = msat_term_is_gt(arg1_t);

  msat_term_is_gt_jretval = (jint)msat_term_is_gt_retval;

  return msat_term_is_gt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1geq
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_geq_retval;
  jint msat_term_is_geq_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_geq_retval = msat_term_is_geq(arg1_t);

  msat_term_is_geq_jretval = (jint)msat_term_is_geq_retval;

  return msat_term_is_geq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_plus_retval;
  jint msat_term_is_plus_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_plus_retval = msat_term_is_plus(arg1_t);

  msat_term_is_plus_jretval = (jint)msat_term_is_plus_retval;

  return msat_term_is_plus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_minus_retval;
  jint msat_term_is_minus_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_minus_retval = msat_term_is_minus(arg1_t);

  msat_term_is_minus_jretval = (jint)msat_term_is_minus_retval;

  return msat_term_is_minus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_times_retval;
  jint msat_term_is_times_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_times_retval = msat_term_is_times(arg1_t);

  msat_term_is_times_jretval = (jint)msat_term_is_times_retval;

  return msat_term_is_times_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1negate
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_negate_retval;
  jint msat_term_is_negate_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_negate_retval = msat_term_is_negate(arg1_t);

  msat_term_is_negate_jretval = (jint)msat_term_is_negate_retval;

  return msat_term_is_negate_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1concat
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_concat_retval;
  jint msat_term_is_bv_concat_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_concat_retval = msat_term_is_bv_concat(arg1_t);

  msat_term_is_bv_concat_jretval = (jint)msat_term_is_bv_concat_retval;

  return msat_term_is_bv_concat_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1select
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_select_retval;
  jint msat_term_is_bv_select_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_select_retval = msat_term_is_bv_select(arg1_t);

  msat_term_is_bv_select_jretval = (jint)msat_term_is_bv_select_retval;

  return msat_term_is_bv_select_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1or
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_or_retval;
  jint msat_term_is_bv_or_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_or_retval = msat_term_is_bv_or(arg1_t);

  msat_term_is_bv_or_jretval = (jint)msat_term_is_bv_or_retval;

  return msat_term_is_bv_or_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1xor
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_xor_retval;
  jint msat_term_is_bv_xor_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_xor_retval = msat_term_is_bv_xor(arg1_t);

  msat_term_is_bv_xor_jretval = (jint)msat_term_is_bv_xor_retval;

  return msat_term_is_bv_xor_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1and
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_and_retval;
  jint msat_term_is_bv_and_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_and_retval = msat_term_is_bv_and(arg1_t);

  msat_term_is_bv_and_jretval = (jint)msat_term_is_bv_and_retval;

  return msat_term_is_bv_and_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1not
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_not_retval;
  jint msat_term_is_bv_not_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_not_retval = msat_term_is_bv_not(arg1_t);

  msat_term_is_bv_not_jretval = (jint)msat_term_is_bv_not_retval;

  return msat_term_is_bv_not_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1lsl
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_lsl_retval;
  jint msat_term_is_bv_lsl_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_lsl_retval = msat_term_is_bv_lsl(arg1_t);

  msat_term_is_bv_lsl_jretval = (jint)msat_term_is_bv_lsl_retval;

  return msat_term_is_bv_lsl_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1lsr
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_lsr_retval;
  jint msat_term_is_bv_lsr_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_lsr_retval = msat_term_is_bv_lsr(arg1_t);

  msat_term_is_bv_lsr_jretval = (jint)msat_term_is_bv_lsr_retval;

  return msat_term_is_bv_lsr_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1asr
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_asr_retval;
  jint msat_term_is_bv_asr_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_asr_retval = msat_term_is_bv_asr(arg1_t);

  msat_term_is_bv_asr_jretval = (jint)msat_term_is_bv_asr_retval;

  return msat_term_is_bv_asr_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1zext
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_zext_retval;
  jint msat_term_is_bv_zext_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_zext_retval = msat_term_is_bv_zext(arg1_t);

  msat_term_is_bv_zext_jretval = (jint)msat_term_is_bv_zext_retval;

  return msat_term_is_bv_zext_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sext
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_sext_retval;
  jint msat_term_is_bv_sext_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_sext_retval = msat_term_is_bv_sext(arg1_t);

  msat_term_is_bv_sext_jretval = (jint)msat_term_is_bv_sext_retval;

  return msat_term_is_bv_sext_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1plus
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_plus_retval;
  jint msat_term_is_bv_plus_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_plus_retval = msat_term_is_bv_plus(arg1_t);

  msat_term_is_bv_plus_jretval = (jint)msat_term_is_bv_plus_retval;

  return msat_term_is_bv_plus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1minus
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_minus_retval;
  jint msat_term_is_bv_minus_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_minus_retval = msat_term_is_bv_minus(arg1_t);

  msat_term_is_bv_minus_jretval = (jint)msat_term_is_bv_minus_retval;

  return msat_term_is_bv_minus_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1times
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_times_retval;
  jint msat_term_is_bv_times_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_times_retval = msat_term_is_bv_times(arg1_t);

  msat_term_is_bv_times_jretval = (jint)msat_term_is_bv_times_retval;

  return msat_term_is_bv_times_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1udiv
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_udiv_retval;
  jint msat_term_is_bv_udiv_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_udiv_retval = msat_term_is_bv_udiv(arg1_t);

  msat_term_is_bv_udiv_jretval = (jint)msat_term_is_bv_udiv_retval;

  return msat_term_is_bv_udiv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1urem
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_urem_retval;
  jint msat_term_is_bv_urem_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_urem_retval = msat_term_is_bv_urem(arg1_t);

  msat_term_is_bv_urem_jretval = (jint)msat_term_is_bv_urem_retval;

  return msat_term_is_bv_urem_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sdiv
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_sdiv_retval;
  jint msat_term_is_bv_sdiv_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_sdiv_retval = msat_term_is_bv_sdiv(arg1_t);

  msat_term_is_bv_sdiv_jretval = (jint)msat_term_is_bv_sdiv_retval;

  return msat_term_is_bv_sdiv_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1srem
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_srem_retval;
  jint msat_term_is_bv_srem_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_srem_retval = msat_term_is_bv_srem(arg1_t);

  msat_term_is_bv_srem_jretval = (jint)msat_term_is_bv_srem_retval;

  return msat_term_is_bv_srem_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1smod
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_smod_retval;
  jint msat_term_is_bv_smod_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_smod_retval = msat_term_is_bv_smod(arg1_t);

  msat_term_is_bv_smod_jretval = (jint)msat_term_is_bv_smod_retval;

  return msat_term_is_bv_smod_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1ult
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_ult_retval;
  jint msat_term_is_bv_ult_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_ult_retval = msat_term_is_bv_ult(arg1_t);

  msat_term_is_bv_ult_jretval = (jint)msat_term_is_bv_ult_retval;

  return msat_term_is_bv_ult_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1uleq
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_uleq_retval;
  jint msat_term_is_bv_uleq_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_uleq_retval = msat_term_is_bv_uleq(arg1_t);

  msat_term_is_bv_uleq_jretval = (jint)msat_term_is_bv_uleq_retval;

  return msat_term_is_bv_uleq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1ugt
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_ugt_retval;
  jint msat_term_is_bv_ugt_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_ugt_retval = msat_term_is_bv_ugt(arg1_t);

  msat_term_is_bv_ugt_jretval = (jint)msat_term_is_bv_ugt_retval;

  return msat_term_is_bv_ugt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1ugeq
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_ugeq_retval;
  jint msat_term_is_bv_ugeq_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_ugeq_retval = msat_term_is_bv_ugeq(arg1_t);

  msat_term_is_bv_ugeq_jretval = (jint)msat_term_is_bv_ugeq_retval;

  return msat_term_is_bv_ugeq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1slt
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_slt_retval;
  jint msat_term_is_bv_slt_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_slt_retval = msat_term_is_bv_slt(arg1_t);

  msat_term_is_bv_slt_jretval = (jint)msat_term_is_bv_slt_retval;

  return msat_term_is_bv_slt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sleq
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_sleq_retval;
  jint msat_term_is_bv_sleq_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_sleq_retval = msat_term_is_bv_sleq(arg1_t);

  msat_term_is_bv_sleq_jretval = (jint)msat_term_is_bv_sleq_retval;

  return msat_term_is_bv_sleq_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sgt
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_sgt_retval;
  jint msat_term_is_bv_sgt_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_sgt_retval = msat_term_is_bv_sgt(arg1_t);

  msat_term_is_bv_sgt_jretval = (jint)msat_term_is_bv_sgt_retval;

  return msat_term_is_bv_sgt_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1term_1is_1bv_1sgeq
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  int msat_term_is_bv_sgeq_retval;
  jint msat_term_is_bv_sgeq_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_is_bv_sgeq_retval = msat_term_is_bv_sgeq(arg1_t);

  msat_term_is_bv_sgeq_jretval = (jint)msat_term_is_bv_sgeq_retval;

  return msat_term_is_bv_sgeq_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1term_1get_1decl
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  msat_decl msat_term_get_decl_retval;
  jlong msat_term_get_decl_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_get_decl_retval = msat_term_get_decl(arg1_t);

  msat_term_get_decl_jretval = (jlong)((size_t)(msat_term_get_decl_retval.repr));

  return msat_term_get_decl_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1decl_1get_1return_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  msat_type msat_decl_get_return_type_retval;
  jint msat_decl_get_return_type_jretval;

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_get_return_type_retval = msat_decl_get_return_type(arg1_d);

  msat_decl_get_return_type_jretval = (jint)msat_decl_get_return_type_retval;

  return msat_decl_get_return_type_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1decl_1get_1arity
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  int msat_decl_get_arity_retval;
  jint msat_decl_get_arity_jretval;

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_get_arity_retval = msat_decl_get_arity(arg1_d);

  msat_decl_get_arity_jretval = (jint)msat_decl_get_arity_retval;

  return msat_decl_get_arity_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1decl_1get_1arg_1type
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_decl arg1_d;
  int arg2_n;
  msat_type msat_decl_get_arg_type_retval;
  jint msat_decl_get_arg_type_jretval;

arg1_d.repr = (void *)((size_t)arg1);
arg2_n = arg2;

  msat_decl_get_arg_type_retval = msat_decl_get_arg_type(arg1_d, arg2_n);

  msat_decl_get_arg_type_jretval = (jint)msat_decl_get_arg_type_retval;

  return msat_decl_get_arg_type_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1decl_1get_1name
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_decl arg1_d;
  char * msat_decl_get_name_retval;
  jstring msat_decl_get_name_jretval;

arg1_d.repr = (void *)((size_t)arg1);

  msat_decl_get_name_retval = msat_decl_get_name(arg1_d);

  msat_decl_get_name_jretval = (*jenv)->NewStringUTF(jenv, msat_decl_get_name_retval);

  free(msat_decl_get_name_retval);

  return msat_decl_get_name_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1term_1get_1name
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_t;
  char * msat_term_get_name_retval;
  jstring msat_term_get_name_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t.repr = (void *)((size_t)arg2);

  msat_term_get_name_retval = msat_term_get_name(arg1_e, arg2_t);

  msat_term_get_name_jretval = (*jenv)->NewStringUTF(jenv, msat_term_get_name_retval);

  free(msat_term_get_name_retval);

  return msat_term_get_name_jretval;

}

JNIEXPORT jstring JNICALL Java_mathsat_api_msat_1term_1repr
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_term arg1_t;
  char * msat_term_repr_retval;
  jstring msat_term_repr_jretval;

arg1_t.repr = (void *)((size_t)arg1);

  msat_term_repr_retval = msat_term_repr(arg1_t);

  msat_term_repr_jretval = (*jenv)->NewStringUTF(jenv, msat_term_repr_retval);

  free(msat_term_repr_retval);

  return msat_term_repr_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1add_1theory
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  msat_theory arg2_t;
  int msat_add_theory_retval;
  jint msat_add_theory_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t = arg2;

  msat_add_theory_retval = msat_add_theory(arg1_e, arg2_t);

  msat_add_theory_jretval = (jint)msat_add_theory_retval;

  return msat_add_theory_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1set_1theory_1combination
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  msat_theory_combination arg2_which;
  int msat_set_theory_combination_retval;
  jint msat_set_theory_combination_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_which = arg2;

  msat_set_theory_combination_retval = msat_set_theory_combination(arg1_e, arg2_which);

  msat_set_theory_combination_jretval = (jint)msat_set_theory_combination_retval;

  return msat_set_theory_combination_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1push_1backtrack_1point
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_push_backtrack_point_retval;
  jint msat_push_backtrack_point_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_push_backtrack_point_retval = msat_push_backtrack_point(arg1_e);

  msat_push_backtrack_point_jretval = (jint)msat_push_backtrack_point_retval;

  return msat_push_backtrack_point_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1pop_1backtrack_1point
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_pop_backtrack_point_retval;
  jint msat_pop_backtrack_point_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_pop_backtrack_point_retval = msat_pop_backtrack_point(arg1_e);

  msat_pop_backtrack_point_jretval = (jint)msat_pop_backtrack_point_retval;

  return msat_pop_backtrack_point_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1assert_1formula
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_formula;
  int msat_assert_formula_retval;
  jint msat_assert_formula_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);

  msat_assert_formula_retval = msat_assert_formula(arg1_e, arg2_formula);

  msat_assert_formula_jretval = (jint)msat_assert_formula_retval;

  return msat_assert_formula_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1solve
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_result msat_solve_retval;
  jint msat_solve_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_solve_retval = msat_solve(arg1_e);

  msat_solve_jretval = (jint)msat_solve_retval;

  return msat_solve_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1all_1sat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jint arg3,
   jobject arg4, jint arg5)
{
    struct j_msat_all_sat_helper helper = {jenv, arg4};
    msat_env e;
    msat_term *important;
    int retval;
    int i;
    int len;
    jlong *larr;
  
    e.repr = (void *)((size_t)arg1);
    len = (int)(*jenv)->GetArrayLength(jenv, arg2);
    important = malloc(sizeof(msat_term) * len);

    larr = (*jenv)->GetLongArrayElements(jenv, arg2, NULL);
    if (larr == NULL) return 0; /* out of memory error */
    for (i = 0; i < len; ++i) {
        important[i].repr = (void *)((size_t)larr[i]);
    }
    (*jenv)->ReleaseLongArrayElements(jenv, arg2, larr, 0);

    retval = msat_all_sat(e, important, len, call_java_callback, &helper);

    free(important);

    return retval;
}


JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1model_1value
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_env arg1_e;
  msat_term arg2_term;
  msat_term msat_get_model_value_retval;
  jlong msat_get_model_value_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_term.repr = (void *)((size_t)arg2);

  msat_get_model_value_retval = msat_get_model_value(arg1_e, arg2_term);

  msat_get_model_value_jretval = (jlong)((size_t)(msat_get_model_value_retval.repr));

  return msat_get_model_value_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1model_1iterator
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_model_iterator msat_create_model_iterator_retval;
  jlong msat_create_model_iterator_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_create_model_iterator_retval = msat_create_model_iterator(arg1_e);

  msat_create_model_iterator_jretval = (jlong)((size_t)(msat_create_model_iterator_retval.repr));

  return msat_create_model_iterator_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1model_1iterator_1has_1next
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_model_iterator arg1_i;
  int msat_model_iterator_has_next_retval;
  jint msat_model_iterator_has_next_jretval;

arg1_i.repr = (void *)((size_t)arg1);

  msat_model_iterator_has_next_retval = msat_model_iterator_has_next(arg1_i);

  msat_model_iterator_has_next_jretval = (jint)msat_model_iterator_has_next_retval;

  return msat_model_iterator_has_next_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1model_1iterator_1next
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jlongArray arg3)
{
  msat_model_iterator arg1_i;
  msat_term * arg2_t;
  msat_term * arg3_v;
  int msat_model_iterator_next_retval;
  jint msat_model_iterator_next_jretval;

arg1_i.repr = (void *)((size_t)arg1);
msat_term ptrarg2_t;
arg2_t = &ptrarg2_t;

msat_term ptrarg3_v;
arg3_v = &ptrarg3_v;


  msat_model_iterator_next_retval = msat_model_iterator_next(arg1_i, arg2_t, arg3_v);

  msat_model_iterator_next_jretval = (jint)msat_model_iterator_next_retval;
(*jenv)->SetLongArrayRegion(jenv, arg3, 0, 1, (jlong *)&(ptrarg3_v.repr));

(*jenv)->SetLongArrayRegion(jenv, arg2, 0, 1, (jlong *)&(ptrarg2_t.repr));


  return msat_model_iterator_next_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1model_1iterator
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_model_iterator arg1_i;

arg1_i.repr = (void *)((size_t)arg1);

  msat_destroy_model_iterator(arg1_i);

}

JNIEXPORT jlongArray JNICALL Java_mathsat_api_msat_1get_1theory_1lemmas
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  msat_term ** arg2_out;
  int msat_get_theory_lemmas_retval;
  jlongArray msat_get_theory_lemmas_jretval;

arg1_e.repr = (void *)((size_t)arg1);
msat_term *ptr_tmp = NULL;
arg2_out = &ptr_tmp;


  msat_get_theory_lemmas_retval = msat_get_theory_lemmas(arg1_e, arg2_out);

  if (msat_get_theory_lemmas_retval > 0) {
  msat_get_theory_lemmas_jretval = (*jenv)->NewLongArray(jenv, (size_t)msat_get_theory_lemmas_retval);
  {
    jlong *jarr = malloc(sizeof(jlong) * (size_t)msat_get_theory_lemmas_retval);
    int i;
    for (i = 0; i < (size_t)msat_get_theory_lemmas_retval; ++i) {
        jarr[i] = (jlong)((size_t)ptr_tmp[i].repr);
    }
    (*jenv)->SetLongArrayRegion(jenv, msat_get_theory_lemmas_jretval, 0, (size_t)msat_get_theory_lemmas_retval, jarr);
    free(jarr);
  }
} else {
  msat_get_theory_lemmas_jretval = (*jenv)->NewLongArray(jenv, 0);
}

if (ptr_tmp) {
  free(ptr_tmp);
}


  return msat_get_theory_lemmas_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1unsat_1core
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  msat_term msat_get_unsat_core_retval;
  jlong msat_get_unsat_core_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_get_unsat_core_retval = msat_get_unsat_core(arg1_e);

  msat_get_unsat_core_jretval = (jlong)((size_t)(msat_get_unsat_core_retval.repr));

  return msat_get_unsat_core_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1create_1tcc_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  int arg2_non_chrono_backtracking;
  msat_tcc_env msat_create_tcc_env_retval;
  jlong msat_create_tcc_env_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_non_chrono_backtracking = arg2;

  msat_create_tcc_env_retval = msat_create_tcc_env(arg1_e, arg2_non_chrono_backtracking);

  msat_create_tcc_env_jretval = (jlong)((size_t)(msat_create_tcc_env_retval.repr));

  return msat_create_tcc_env_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1destroy_1tcc_1env
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_tcc_env arg1_e;

arg1_e.repr = (void *)((size_t)arg1);

  msat_destroy_tcc_env(arg1_e);

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1add_1theory
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_tcc_env arg1_e;
  msat_theory arg2_t;
  int msat_tcc_add_theory_retval;
  jint msat_tcc_add_theory_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_t = arg2;

  msat_tcc_add_theory_retval = msat_tcc_add_theory(arg1_e, arg2_t);

  msat_tcc_add_theory_jretval = (jint)msat_tcc_add_theory_retval;

  return msat_tcc_add_theory_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1add_1constraint
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_tcc_env arg1_e;
  msat_term arg2_atom;
  int msat_tcc_add_constraint_retval;
  jint msat_tcc_add_constraint_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_atom.repr = (void *)((size_t)arg2);

  msat_tcc_add_constraint_retval = msat_tcc_add_constraint(arg1_e, arg2_atom);

  msat_tcc_add_constraint_jretval = (jint)msat_tcc_add_constraint_retval;

  return msat_tcc_add_constraint_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1assert_1formula
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_tcc_env arg1_e;
  msat_term arg2_formula;
  int msat_tcc_assert_formula_retval;
  jint msat_tcc_assert_formula_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_formula.repr = (void *)((size_t)arg2);

  msat_tcc_assert_formula_retval = msat_tcc_assert_formula(arg1_e, arg2_formula);

  msat_tcc_assert_formula_jretval = (jint)msat_tcc_assert_formula_retval;

  return msat_tcc_assert_formula_jretval;

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1tcc_1assume
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jint arg3)
{
  msat_tcc_env arg1_e;
  msat_term arg2_atom;
  int arg3_positive;

arg1_e.repr = (void *)((size_t)arg1);
arg2_atom.repr = (void *)((size_t)arg2);
arg3_positive = arg3;

  msat_tcc_assume(arg1_e, arg2_atom, arg3_positive);

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1tcc_1undo
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_tcc_env arg1_e;
  msat_term arg2_atom;

arg1_e.repr = (void *)((size_t)arg1);
arg2_atom.repr = (void *)((size_t)arg2);

  msat_tcc_undo(arg1_e, arg2_atom);

}

JNIEXPORT void JNICALL Java_mathsat_api_msat_1tcc_1undo_1all
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_tcc_env arg1_e;

arg1_e.repr = (void *)((size_t)arg1);

  msat_tcc_undo_all(arg1_e);

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1check
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2, jlongArray arg3)
{
  msat_tcc_env arg1_e;
  int arg2_approx;
  msat_term * arg3_to_undo;
  msat_result msat_tcc_check_retval;
  jint msat_tcc_check_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_approx = arg2;
msat_term ptrarg3_to_undo;
arg3_to_undo = &ptrarg3_to_undo;


  msat_tcc_check_retval = msat_tcc_check(arg1_e, arg2_approx, arg3_to_undo);

  msat_tcc_check_jretval = (jint)msat_tcc_check_retval;
(*jenv)->SetLongArrayRegion(jenv, arg3, 0, 1, (jlong *)&(ptrarg3_to_undo.repr));


  return msat_tcc_check_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1get_1value
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2)
{
  msat_tcc_env arg1_e;
  msat_term arg2_atom;
  msat_truth_value msat_tcc_get_value_retval;
  jint msat_tcc_get_value_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_atom.repr = (void *)((size_t)arg2);

  msat_tcc_get_value_retval = msat_tcc_get_value(arg1_e, arg2_atom);

  msat_tcc_get_value_jretval = (jint)msat_tcc_get_value_retval;

  return msat_tcc_get_value_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1get_1reason
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlong arg2, jlongArray arg3)
{
  msat_tcc_env arg1_e;
  msat_term arg2_atom;
  msat_term * arg3_reason;
  int msat_tcc_get_reason_retval;
  jint msat_tcc_get_reason_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_atom.repr = (void *)((size_t)arg2);
msat_term ptrarg3_reason;
arg3_reason = &ptrarg3_reason;


  msat_tcc_get_reason_retval = msat_tcc_get_reason(arg1_e, arg2_atom, arg3_reason);

  msat_tcc_get_reason_jretval = (jint)msat_tcc_get_reason_retval;
(*jenv)->SetLongArrayRegion(jenv, arg3, 0, 1, (jlong *)&(ptrarg3_reason.repr));


  return msat_tcc_get_reason_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1has_1implied
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_tcc_env arg1_e;
  int msat_tcc_has_implied_retval;
  jint msat_tcc_has_implied_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_tcc_has_implied_retval = msat_tcc_has_implied(arg1_e);

  msat_tcc_has_implied_jretval = (jint)msat_tcc_has_implied_retval;

  return msat_tcc_has_implied_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1get_1implied
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2)
{
  msat_tcc_env arg1_e;
  msat_term * arg2_implied;
  int msat_tcc_get_implied_retval;
  jint msat_tcc_get_implied_jretval;

arg1_e.repr = (void *)((size_t)arg1);
msat_term ptrarg2_implied;
arg2_implied = &ptrarg2_implied;


  msat_tcc_get_implied_retval = msat_tcc_get_implied(arg1_e, arg2_implied);

  msat_tcc_get_implied_jretval = (jint)msat_tcc_get_implied_retval;
(*jenv)->SetLongArrayRegion(jenv, arg2, 0, 1, (jlong *)&(ptrarg2_implied.repr));


  return msat_tcc_get_implied_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1solve
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2)
{
  msat_tcc_env arg1_e;
  msat_term * arg2_to_undo;
  msat_result msat_tcc_solve_retval;
  jint msat_tcc_solve_jretval;

arg1_e.repr = (void *)((size_t)arg1);
msat_term ptrarg2_to_undo;
arg2_to_undo = &ptrarg2_to_undo;


  msat_tcc_solve_retval = msat_tcc_solve(arg1_e, arg2_to_undo);

  msat_tcc_solve_jretval = (jint)msat_tcc_solve_retval;
(*jenv)->SetLongArrayRegion(jenv, arg2, 0, 1, (jlong *)&(ptrarg2_to_undo.repr));


  return msat_tcc_solve_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1tcc_1all_1sat
  (JNIEnv *jenv, jclass jcls, jlong arg1, jlongArray arg2, jint arg3,
   jobject arg4, jint arg5)
{
    struct j_msat_all_sat_helper helper = {jenv, arg4};
    msat_tcc_env e;
    msat_term *important;
    int retval;
    int i;
    int len;
    jlong *larr;
  
    e.repr = (void *)((size_t)arg1);
    len = (int)(*jenv)->GetArrayLength(jenv, arg2);
    important = malloc(sizeof(msat_term) * len);

    larr = (*jenv)->GetLongArrayElements(jenv, arg2, NULL);
    if (larr == NULL) return 0; /* out of memory error */
    for (i = 0; i < len; ++i) {
        important[i].repr = (void *)((size_t)larr[i]);
    }
    (*jenv)->ReleaseLongArrayElements(jenv, arg2, larr, 0);

    retval = msat_tcc_all_sat(e, important, len, call_java_callback, &helper);

    free(important);

    return retval;
}


JNIEXPORT jint JNICALL Java_mathsat_api_msat_1init_1interpolation
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_init_interpolation_retval;
  jint msat_init_interpolation_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_init_interpolation_retval = msat_init_interpolation(arg1_e);

  msat_init_interpolation_jretval = (jint)msat_init_interpolation_retval;

  return msat_init_interpolation_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1create_1itp_1group
  (JNIEnv *jenv, jclass jcls, jlong arg1)
{
  msat_env arg1_e;
  int msat_create_itp_group_retval;
  jint msat_create_itp_group_jretval;

arg1_e.repr = (void *)((size_t)arg1);

  msat_create_itp_group_retval = msat_create_itp_group(arg1_e);

  msat_create_itp_group_jretval = (jint)msat_create_itp_group_retval;

  return msat_create_itp_group_jretval;

}

JNIEXPORT jint JNICALL Java_mathsat_api_msat_1set_1itp_1group
  (JNIEnv *jenv, jclass jcls, jlong arg1, jint arg2)
{
  msat_env arg1_e;
  int arg2_group;
  int msat_set_itp_group_retval;
  jint msat_set_itp_group_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_group = arg2;

  msat_set_itp_group_retval = msat_set_itp_group(arg1_e, arg2_group);

  msat_set_itp_group_jretval = (jint)msat_set_itp_group_retval;

  return msat_set_itp_group_jretval;

}

JNIEXPORT jlong JNICALL Java_mathsat_api_msat_1get_1interpolant
  (JNIEnv *jenv, jclass jcls, jlong arg1, jintArray arg2, jint arg3)
{
  msat_env arg1_e;
  int * arg2_groups_of_a;
  size_t arg3_n;
  msat_term msat_get_interpolant_retval;
  jlong msat_get_interpolant_jretval;

arg1_e.repr = (void *)((size_t)arg1);
arg2_groups_of_a = (int *)((*jenv)->GetIntArrayElements(jenv, arg2, NULL));
if (arg2_groups_of_a == NULL) return 0; /* out of memory error */

arg3_n = arg3;

  msat_get_interpolant_retval = msat_get_interpolant(arg1_e, arg2_groups_of_a, arg3_n);

  msat_get_interpolant_jretval = (jlong)((size_t)(msat_get_interpolant_retval.repr));
(*jenv)->ReleaseIntArrayElements(jenv, arg2, arg2_groups_of_a, 0);


  return msat_get_interpolant_jretval;

}
